<?php

namespace ContainerYLYnYtZ;
include_once \dirname(__DIR__, 4).'/vendor/knplabs/knp-components/src/Knp/Component/Pager/PaginatorInterface.php';
include_once \dirname(__DIR__, 4).'/vendor/knplabs/knp-components/src/Knp/Component/Pager/Paginator.php';

class PaginatorInterface_82dac15 implements \ProxyManager\Proxy\VirtualProxyInterface, \Knp\Component\Pager\PaginatorInterface
{
    /**
     * @var \Knp\Component\Pager\PaginatorInterface|null wrapped object, if the proxy is initialized
     */
    private $valueHolder8ddaf = null;

    /**
     * @var \Closure|null initializer responsible for generating the wrapped object
     */
    private $initializer5f264 = null;

    /**
     * @var bool[] map of public properties of the parent class
     */
    private static $publicProperties91196 = [
        
    ];

    public function paginate($target, int $page = 1, ?int $limit = null, array $options = []) : \Knp\Component\Pager\Pagination\PaginationInterface
    {
        $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, 'paginate', array('target' => $target, 'page' => $page, 'limit' => $limit, 'options' => $options), $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;

        if ($this->valueHolder8ddaf === $returnValue = $this->valueHolder8ddaf->paginate($target, $page, $limit, $options)) {
            return $this;
        }

        return $returnValue;
    }

    /**
     * Constructor for lazy initialization
     *
     * @param \Closure|null $initializer
     */
    public static function staticProxyConstructor($initializer)
    {
        static $reflection;

        $reflection = $reflection ?? new \ReflectionClass(__CLASS__);
        $instance   = $reflection->newInstanceWithoutConstructor();

        $instance->initializer5f264 = $initializer;

        return $instance;
    }

    public function __construct()
    {
        static $reflection;

        if (! $this->valueHolder8ddaf) {
            $reflection = $reflection ?? new \ReflectionClass('Knp\\Component\\Pager\\PaginatorInterface');
            $this->valueHolder8ddaf = $reflection->newInstanceWithoutConstructor();
        }
    }

    public function & __get($name)
    {
        $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, '__get', ['name' => $name], $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;

        if (isset(self::$publicProperties91196[$name])) {
            return $this->valueHolder8ddaf->$name;
        }

        $realInstanceReflection = new \ReflectionClass('Knp\\Component\\Pager\\PaginatorInterface');

        if (! $realInstanceReflection->hasProperty($name)) {
            $targetObject = $this->valueHolder8ddaf;

            $backtrace = debug_backtrace(false, 1);
            trigger_error(
                sprintf(
                    'Undefined property: %s::$%s in %s on line %s',
                    $realInstanceReflection->getName(),
                    $name,
                    $backtrace[0]['file'],
                    $backtrace[0]['line']
                ),
                \E_USER_NOTICE
            );
            return $targetObject->$name;
        }

        $targetObject = $this->valueHolder8ddaf;
        $accessor = function & () use ($targetObject, $name) {
            return $targetObject->$name;
        };
        $backtrace = debug_backtrace(true, 2);
        $scopeObject = isset($backtrace[1]['object']) ? $backtrace[1]['object'] : new \ProxyManager\Stub\EmptyClassStub();
        $accessor = $accessor->bindTo($scopeObject, get_class($scopeObject));
        $returnValue = & $accessor();

        return $returnValue;
    }

    public function __set($name, $value)
    {
        $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, '__set', array('name' => $name, 'value' => $value), $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;

        $realInstanceReflection = new \ReflectionClass('Knp\\Component\\Pager\\PaginatorInterface');

        if (! $realInstanceReflection->hasProperty($name)) {
            $targetObject = $this->valueHolder8ddaf;

            $targetObject->$name = $value;

            return $targetObject->$name;
        }

        $targetObject = $this->valueHolder8ddaf;
        $accessor = function & () use ($targetObject, $name, $value) {
            $targetObject->$name = $value;

            return $targetObject->$name;
        };
        $backtrace = debug_backtrace(true, 2);
        $scopeObject = isset($backtrace[1]['object']) ? $backtrace[1]['object'] : new \ProxyManager\Stub\EmptyClassStub();
        $accessor = $accessor->bindTo($scopeObject, get_class($scopeObject));
        $returnValue = & $accessor();

        return $returnValue;
    }

    public function __isset($name)
    {
        $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, '__isset', array('name' => $name), $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;

        $realInstanceReflection = new \ReflectionClass('Knp\\Component\\Pager\\PaginatorInterface');

        if (! $realInstanceReflection->hasProperty($name)) {
            $targetObject = $this->valueHolder8ddaf;

            return isset($targetObject->$name);
        }

        $targetObject = $this->valueHolder8ddaf;
        $accessor = function () use ($targetObject, $name) {
            return isset($targetObject->$name);
        };
        $backtrace = debug_backtrace(true, 2);
        $scopeObject = isset($backtrace[1]['object']) ? $backtrace[1]['object'] : new \ProxyManager\Stub\EmptyClassStub();
        $accessor = $accessor->bindTo($scopeObject, get_class($scopeObject));
        $returnValue = $accessor();

        return $returnValue;
    }

    public function __unset($name)
    {
        $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, '__unset', array('name' => $name), $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;

        $realInstanceReflection = new \ReflectionClass('Knp\\Component\\Pager\\PaginatorInterface');

        if (! $realInstanceReflection->hasProperty($name)) {
            $targetObject = $this->valueHolder8ddaf;

            unset($targetObject->$name);

            return;
        }

        $targetObject = $this->valueHolder8ddaf;
        $accessor = function () use ($targetObject, $name) {
            unset($targetObject->$name);

            return;
        };
        $backtrace = debug_backtrace(true, 2);
        $scopeObject = isset($backtrace[1]['object']) ? $backtrace[1]['object'] : new \ProxyManager\Stub\EmptyClassStub();
        $accessor = $accessor->bindTo($scopeObject, get_class($scopeObject));
        $accessor();
    }

    public function __clone()
    {
        $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, '__clone', array(), $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;

        $this->valueHolder8ddaf = clone $this->valueHolder8ddaf;
    }

    public function __sleep()
    {
        $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, '__sleep', array(), $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;

        return array('valueHolder8ddaf');
    }

    public function __wakeup()
    {
    }

    public function setProxyInitializer(?\Closure $initializer = null) : void
    {
        $this->initializer5f264 = $initializer;
    }

    public function getProxyInitializer() : ?\Closure
    {
        return $this->initializer5f264;
    }

    public function initializeProxy() : bool
    {
        return $this->initializer5f264 && ($this->initializer5f264->__invoke($valueHolder8ddaf, $this, 'initializeProxy', array(), $this->initializer5f264) || 1) && $this->valueHolder8ddaf = $valueHolder8ddaf;
    }

    public function isProxyInitialized() : bool
    {
        return null !== $this->valueHolder8ddaf;
    }

    public function getWrappedValueHolderValue()
    {
        return $this->valueHolder8ddaf;
    }
}

if (!\class_exists('PaginatorInterface_82dac15', false)) {
    \class_alias(__NAMESPACE__.'\\PaginatorInterface_82dac15', 'PaginatorInterface_82dac15', false);
}
